diff --git a/src/backend/access/transam/rmgr.c b/src/backend/access/transam/rmgr.c
index 4fda03a3cf..305ada93e8 100644
--- a/src/backend/access/transam/rmgr.c
+++ b/src/backend/access/transam/rmgr.c
@@ -39,6 +39,7 @@
 #include "replication/message.h"
 #include "replication/origin.h"
 #include "storage/standby.h"
+#include "access/pgupgrade_wal.h"	/* RM_PG_UPGRADE_ID */
 #include "utils/relmapper.h"
 /* IWYU pragma: end_keep */
 
diff --git a/src/backend/access/transam/slru.c b/src/backend/access/transam/slru.c
index 47dd52d674..b6ca7682c4 100644
--- a/src/backend/access/transam/slru.c
+++ b/src/backend/access/transam/slru.c
@@ -1443,6 +1443,77 @@ SimpleLruWriteAll(SlruDesc *ctl, bool allow_redirtied)
 		fsync_fname(ctl->options.Dir, true);
 }
 
+/*
+ * Restore one SLRU segment's worth of pages from a captured image during
+ * pg_upgrade --wal-upgrade WAL replay (XLOG_UPGRADE_SLRU_DATA redo).
+ *
+ * "segno" is the SLRU segment number; "data" is the raw segment image and
+ * "datalen" its length (a whole number of BLCKSZ pages, padded to a full
+ * segment by the emit side).  For each page the captured image is installed
+ * into a SimpleLru buffer, marked dirty, and flushed to disk immediately.
+ *
+ * The image is the final, merged CLOG/multixact state captured after the whole
+ * upgrade completed, so it is authoritative: it dominates anything an earlier
+ * replayed commit record wrote for the same page (this record is emitted last)
+ * and it does not depend on the on-disk SLRU segment file, which pg_upgrade has
+ * unlinked as part of skipping the disk writes.
+ *
+ * The SLRU directory (ctl->Dir) is recreated earlier in replay by the
+ * XLOG_UPGRADE_DIRTREE record (the logged after-image of the initdb directory
+ * tree), so it is guaranteed to exist by the time we write a segment here.
+ */
+void
+SlruUpgradeRestoreSegment(SlruDesc *ctl, int64 segno,
+						  const char *data, Size datalen)
+{
+	int			npages = (int) (datalen / BLCKSZ);
+	int64		basepage = segno * SLRU_PAGES_PER_SEGMENT;
+	SlruWriteAllData fdata;
+
+	/*
+	 * Write the whole segment through a single SlruWriteAll batch so the
+	 * segment file is opened once, not once per page.  Passing &fdata to
+	 * SlruInternalWritePage makes SlruPhysicalWritePage cache and reuse the
+	 * open fd across all of this segment's pages (exactly as
+	 * SimpleLruWriteAll does at checkpoint); we close it once at the end. All
+	 * pages of one segment share a bank on well-configured SLRUs, but acquire
+	 * the correct bank lock per page to stay correct regardless of bank
+	 * layout.
+	 */
+	fdata.num_files = 0;
+
+	for (int i = 0; i < npages; i++)
+	{
+		int64		pageno = basepage + i;
+		LWLock	   *lock = SimpleLruGetBankLock(ctl, pageno);
+		int			slotno;
+
+		LWLockAcquire(lock, LW_EXCLUSIVE);
+
+		/* allocate/zero a buffer slot for this page, then overwrite it */
+		slotno = SimpleLruZeroPage(ctl, pageno);	/* also marks the slot
+													 * dirty */
+		memcpy(ctl->shared->page_buffer[slotno],
+			   data + (Size) i * BLCKSZ, BLCKSZ);
+
+		/* persist through the batch (reuses the cached fd for this segment) */
+		SlruInternalWritePage(ctl, slotno, &fdata);
+
+		LWLockRelease(lock);
+	}
+
+	/* Close the fd(s) the batch left open. */
+	for (int i = 0; i < fdata.num_files; i++)
+	{
+		if (CloseTransientFile(fdata.fd[i]) != 0)
+		{
+			slru_errcause = SLRU_CLOSE_FAILED;
+			slru_errno = errno;
+			SlruReportIOError(ctl, basepage, NULL);
+		}
+	}
+}
+
 /*
  * Remove all segments before the one holding the passed page number
  *
diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index a81912b744..1c364c0f54 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -46,7 +46,10 @@
 #include <sys/time.h>
 #include <unistd.h>
 
-#include "access/clog.h"
+#include "access/clog.h"		/* CheckPointCLOG for XLogFlushUpgradeSLRU */
+#include "access/pgupgrade_wal.h"	/* RM_PG_UPGRADE_ID, pg_upgrade WAL
+									 * functions */
+#include "access/slru.h"		/* SLRU_PAGES_PER_SEGMENT for upgrade WAL */
 #include "access/commit_ts.h"
 #include "access/heaptoast.h"
 #include "access/multixact.h"
@@ -86,6 +89,7 @@
 #include "replication/walreceiver.h"
 #include "replication/walsender.h"
 #include "storage/bufmgr.h"
+#include "storage/copydir.h"
 #include "storage/fd.h"
 #include "storage/ipc.h"
 #include "storage/large_object.h"
@@ -143,6 +147,10 @@ int			max_slot_wal_keep_size_mb = -1;
 int			wal_decode_buffer_size = 512 * 1024;
 bool		track_wal_io_timing = false;
 
+/* pg_upgrade --wal-upgrade streaming-standby options (see xlog.h) */
+int			pg_upgrade_standby_transfer_mode = PG_UPGRADE_XFER_MIRROR;
+char	   *pg_upgrade_standby_old_datadir = NULL;
+
 #ifdef WAL_DEBUG
 bool		XLOG_DEBUG = false;
 #endif
@@ -208,6 +216,21 @@ const struct config_enum_entry archive_mode_options[] = {
 	{NULL, 0, false}
 };
 
+/*
+ * pg_upgrade_standby_transfer_mode options.  "mirror" (the default) means reproduce the
+ * per-file mode the primary recorded in the RELINK manifest; the rest override
+ * it with a specific placement primitive on the standby.
+ */
+const struct config_enum_entry pg_upgrade_standby_transfer_mode_options[] = {
+	{"mirror", PG_UPGRADE_XFER_MIRROR, false},
+	{"clone", PG_UPGRADE_XFER_CLONE, false},
+	{"copy", PG_UPGRADE_XFER_COPY, false},
+	{"copy_file_range", PG_UPGRADE_XFER_COPY_FILE_RANGE, false},
+	{"link", PG_UPGRADE_XFER_LINK, false},
+	{"swap", PG_UPGRADE_XFER_SWAP, false},
+	{NULL, 0, false}
+};
+
 /*
  * Statistics for current checkpoint are collected in this global struct.
  * Because only the checkpointer or a stand-alone backend can perform
@@ -4402,6 +4425,221 @@ WriteControlFile(void)
 						XLOG_CONTROL_FILE)));
 }
 
+/*
+ * Synthesize a minimal, valid global/pg_control (and PG_VERSION) from this
+ * binary's compile-time constants so a --wal-upgrade recovery can start without
+ * initdb.  Only the compatibility-check fields must be right; the run-time
+ * fields are fixed up afterward by ArmControlFileForUpgradeRecovery().
+ *
+ * allow_overwrite=false creates the file O_EXCL (streaming-standby skeleton,
+ * never clobber an existing one); allow_overwrite=true uses O_TRUNC to replace
+ * the old-version pg_control left by archive-PITR recovery.
+ *
+ * Runs in the postmaster before CreateSharedMemoryAndSemaphores(), so there is
+ * no shared ControlFile yet; a local buffer is built and written directly.
+ */
+void
+SynthesizeUpgradeStreamControlFile(bool allow_overwrite)
+{
+	ControlFileData *cf;
+	char		buffer[PG_CONTROL_FILE_SIZE];	/* need not be aligned */
+	char		verpath[MAXPGPATH];
+	char		globaldir[MAXPGPATH];
+	char		ctlpath[MAXPGPATH];
+	int			fd;
+	char		mock_auth_nonce[MOCK_AUTH_NONCE_LEN];
+
+	/*
+	 * The CWD is not yet the data directory at this point, so build absolute
+	 * paths from DataDir rather than relying on relative names.
+	 */
+	snprintf(globaldir, sizeof(globaldir), "%s/global", DataDir);
+	snprintf(ctlpath, sizeof(ctlpath), "%s/%s", DataDir, XLOG_CONTROL_FILE);
+
+	/*
+	 * On the overwrite (archive-PITR) path, keep an existing valid
+	 * current-version control file.  A same-version PITR restore's base
+	 * backup carries a good new-version pg_control, and clobbering it would
+	 * discard its data_checksum_version (synthesis hardcodes 0), so a
+	 * checksummed cluster would then fail page verification during replay.
+	 * Synthesize only when the existing file is absent or a different major's
+	 * (the real cross-version case).
+	 */
+	if (allow_overwrite)
+	{
+		struct stat st;
+
+		if (stat(ctlpath, &st) == 0)
+		{
+			bool		existing_crc_ok = false;
+			ControlFileData *existing = get_controlfile(DataDir, &existing_crc_ok);
+
+			if (existing != NULL)
+			{
+				bool		usable = (existing_crc_ok &&
+									  existing->pg_control_version == PG_CONTROL_VERSION &&
+									  existing->catalog_version_no == CATALOG_VERSION_NO);
+
+				pfree(existing);
+				if (usable)
+				{
+					ereport(LOG,
+							(errmsg("keeping the existing new-version control file for upgrade-stream recovery"),
+							 errdetail("A valid same-version pg_control is present; not synthesizing over it (preserves its data checksum state).")));
+					return;
+				}
+			}
+		}
+	}
+
+	cf = (ControlFileData *) palloc0(sizeof(ControlFileData));
+
+	if (!pg_strong_random(mock_auth_nonce, MOCK_AUTH_NONCE_LEN))
+		ereport(FATAL,
+				(errcode(ERRCODE_INTERNAL_ERROR),
+				 errmsg("could not generate secret authorization token")));
+
+	/*
+	 * Status fields.  system_identifier is a placeholder (0); the arm
+	 * overwrites it with the WAL's sysid later.  DB_SHUTDOWNED is what the
+	 * arm expects.
+	 */
+	cf->system_identifier = 0;
+	memcpy(cf->mock_authentication_nonce, mock_auth_nonce, MOCK_AUTH_NONCE_LEN);
+	cf->state = DB_SHUTDOWNED;
+	cf->unloggedLSN = FirstNormalUnloggedLSN;
+
+	/*
+	 * Parameter values used when replaying WAL, from this node's GUCs (its
+	 * own postgresql.conf or the built-in defaults, not the primary's).  As
+	 * for any standby, these must be at least the primary's values or
+	 * recovery aborts "because of insufficient parameter settings" when the
+	 * window's PARAMETER_CHANGE record replays.
+	 */
+	cf->MaxConnections = MaxConnections;
+	cf->max_worker_processes = max_worker_processes;
+	cf->max_wal_senders = max_wal_senders;
+	cf->max_prepared_xacts = max_prepared_xacts;
+	cf->max_locks_per_xact = max_locks_per_xact;
+	cf->wal_level = wal_level;
+	cf->wal_log_hints = wal_log_hints;
+	cf->track_commit_timestamp = track_commit_timestamp;
+	cf->data_checksum_version = 0;
+
+	/* Version and compatibility-check fields (all compile-time constants). */
+	cf->pg_control_version = PG_CONTROL_VERSION;
+	cf->catalog_version_no = CATALOG_VERSION_NO;
+	cf->maxAlign = MAXIMUM_ALIGNOF;
+	cf->floatFormat = FLOATFORMAT_VALUE;
+	cf->blcksz = BLCKSZ;
+	cf->relseg_size = RELSEG_SIZE;
+	cf->slru_pages_per_segment = SLRU_PAGES_PER_SEGMENT;
+	cf->xlog_blcksz = XLOG_BLCKSZ;
+	cf->xlog_seg_size = wal_segment_size;
+	cf->nameDataLen = NAMEDATALEN;
+	cf->indexMaxKeys = INDEX_MAX_KEYS;
+	cf->toast_max_chunk_size = TOAST_MAX_CHUNK_SIZE;
+	cf->loblksize = LOBLKSIZE;
+	cf->float8ByVal = true;		/* vestigial */
+	cf->default_char_signedness = true;
+
+	/* CRC over the struct, exactly as WriteControlFile() does. */
+	INIT_CRC32C(cf->crc);
+	COMP_CRC32C(cf->crc, cf, offsetof(ControlFileData, crc));
+	FIN_CRC32C(cf->crc);
+
+	memset(buffer, 0, PG_CONTROL_FILE_SIZE);
+	memcpy(buffer, cf, sizeof(ControlFileData));
+
+	/*
+	 * Create the standard cluster subdirectories initdb would make; startup
+	 * opens some before replaying the window's DIRTREE record.  Mirrors
+	 * initdb.c's subdirs[]; EEXIST is tolerated.
+	 */
+	{
+		static const char *const subdirs[] = {
+			"global", "base", "pg_wal", "pg_wal/archive_status", "pg_wal/summaries",
+			"pg_commit_ts", "pg_dynshmem", "pg_notify", "pg_serial",
+			"pg_snapshots", "pg_subtrans", "pg_twophase",
+			"pg_multixact", "pg_multixact/members", "pg_multixact/offsets",
+			"pg_replslot", "pg_tblspc", "pg_stat", "pg_stat_tmp", "pg_xact",
+			"pg_logical", "pg_logical/snapshots", "pg_logical/mappings"
+		};
+
+		for (int s = 0; s < (int) lengthof(subdirs); s++)
+		{
+			char		dpath[MAXPGPATH];
+
+			snprintf(dpath, sizeof(dpath), "%s/%s", DataDir, subdirs[s]);
+			if (MakePGDirectory(dpath) != 0 && errno != EEXIST)
+				ereport(FATAL,
+						(errcode_for_file_access(),
+						 errmsg("could not create directory \"%s\": %m", dpath)));
+		}
+	}
+
+	/*
+	 * Write global/pg_control: O_EXCL for a streaming standby (must not
+	 * clobber), O_TRUNC for archive-PITR recovery (must replace the
+	 * old-version file).
+	 */
+	fd = BasicOpenFile(ctlpath,
+					   O_RDWR | O_CREAT | PG_BINARY |
+					   (allow_overwrite ? O_TRUNC : O_EXCL));
+	if (fd < 0)
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not create file \"%s\": %m", ctlpath)));
+	errno = 0;
+	if (write(fd, buffer, PG_CONTROL_FILE_SIZE) != PG_CONTROL_FILE_SIZE)
+	{
+		if (errno == 0)
+			errno = ENOSPC;
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not write to file \"%s\": %m", ctlpath)));
+	}
+	if (pg_fsync(fd) != 0)
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not fsync file \"%s\": %m", ctlpath)));
+	if (close(fd) != 0)
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not close file \"%s\": %m", ctlpath)));
+
+	/*
+	 * Write a matching PG_VERSION (major-version stamp checkDataDir
+	 * requires).
+	 */
+	snprintf(verpath, sizeof(verpath), "%s/PG_VERSION", DataDir);
+	fd = BasicOpenFile(verpath, O_RDWR | O_CREAT | O_TRUNC | PG_BINARY);
+	if (fd < 0)
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not create file \"%s\": %m", verpath)));
+	if (write(fd, PG_MAJORVERSION "\n", strlen(PG_MAJORVERSION) + 1) !=
+		(int) (strlen(PG_MAJORVERSION) + 1))
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not write to file \"%s\": %m", verpath)));
+	if (pg_fsync(fd) != 0)
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not fsync file \"%s\": %m", verpath)));
+	if (close(fd) != 0)
+		ereport(FATAL,
+				(errcode_for_file_access(),
+				 errmsg("could not close file \"%s\": %m", verpath)));
+
+	pfree(cf);
+
+	ereport(LOG,
+			(errmsg("synthesized a fresh pg_control and PG_VERSION for an upgrade-stream standby"),
+			 errdetail("The standby will stream and replay the upgrade window from its primary; no initdb was required.")));
+}
+
+
 static void
 ReadControlFile(void)
 {
@@ -4636,6 +4874,171 @@ UpdateControlFile(void)
 	update_controlfile(DataDir, ControlFile, true);
 }
 
+/*
+ * Arm the control file for pg_upgrade --wal-upgrade recovery.
+ *
+ * Points checkPoint at CN (the end-of-upgrade checkpoint) and forces wal_level
+ * to replica so recovery replays from CN through XLOG_UPGRADE_COMPLETE.  State
+ * and minRecoveryPoint differ by mode (see below).  Called before StartupXLOG()
+ * reads checkPointCopy, so the update takes effect this recovery cycle.
+ */
+void
+ArmControlFileForUpgradeRecovery(const struct CheckPoint *cn, XLogRecPtr cn_lsn,
+								 uint64 wal_sysid, bool for_streaming)
+{
+	Assert(ControlFile != NULL);
+
+	ControlFile->checkPoint = cn_lsn;
+	ControlFile->checkPointCopy = *cn;
+	ControlFile->wal_level = WAL_LEVEL_REPLICA;
+	ControlFile->minRecoveryPointTLI = cn->ThisTimeLineID;
+
+	if (for_streaming)
+	{
+		/*
+		 * Streaming standby: CN is not on local disk yet; it must stream in
+		 * from the primary.  InitWalRecovery() enters standby mode only when
+		 * minRecoveryPoint is valid or state == DB_SHUTDOWNED, so set both.
+		 */
+		ControlFile->state = DB_SHUTDOWNED;
+		ControlFile->minRecoveryPoint = cn_lsn;
+	}
+	else
+	{
+		/*
+		 * Local-window arm: the whole window is already in pg_wal/, so
+		 * recover it as ordinary crash recovery, stopping at the end of
+		 * available WAL.
+		 */
+		ControlFile->state = DB_IN_PRODUCTION;
+		ControlFile->minRecoveryPoint = InvalidXLogRecPtr;
+		ControlFile->minRecoveryPointTLI = 0;
+	}
+
+	/*
+	 * Adopt the sysid the upgrade WAL was emitted under so recovery's
+	 * per-page xlp_sysid checks accept the burst.  wal_sysid==0 means the
+	 * scan could not read it; leave pg_control untouched.
+	 */
+	if (wal_sysid != 0)
+		ControlFile->system_identifier = wal_sysid;
+
+	UpdateControlFile();
+}
+
+/*
+ * Informational state flips bracketing the upgrade-window replay: redo calls
+ * these at XLOG_UPGRADE_START and XLOG_UPGRADE_COMPLETE so a crash mid-window
+ * (or pg_controldata) shows "in pg_upgrade".  They do not affect the
+ * recovery-mode decision; Clear restores DB_IN_PRODUCTION.
+ */
+void
+SetControlFileInUpgrade(void)
+{
+	Assert(ControlFile != NULL);
+
+	ControlFile->state = DB_IN_UPGRADE;
+	ControlFile->time = (pg_time_t) time(NULL);
+	UpdateControlFile();
+}
+
+void
+ClearControlFileInUpgrade(void)
+{
+	Assert(ControlFile != NULL);
+
+	if (ControlFile->state == DB_IN_UPGRADE)
+	{
+		ControlFile->state = DB_IN_PRODUCTION;
+		ControlFile->time = (pg_time_t) time(NULL);
+		UpdateControlFile();
+	}
+}
+
+/*
+ * The checkpoint LSN currently recorded in the control file.  Used by
+ * PerformWalUpgradeIfNeeded() as the timeline-independent "already applied?"
+ * signal: once first startup finalizes, this advances past XLOG_UPGRADE_COMPLETE,
+ * whereas a pending upgrade still points at/before CN (which precedes COMPLETE).
+ */
+XLogRecPtr
+GetControlFileCheckPointLSN(void)
+{
+	Assert(ControlFile != NULL);
+	return ControlFile->checkPoint;
+}
+
+/*
+ * --wal-upgrade: durable "upgrade window replayed to COMPLETE" flag.  Set (and
+ * fsync'd) by the XLOG_UPGRADE_COMPLETE redo handler the instant the window
+ * finishes -- one checkpoint BEFORE the end-of-recovery checkpoint advances the
+ * control checkpoint past CN -- so that a crash in that gap leaves the flag set
+ * with the checkpoint still at CN, which PerformWalUpgradeIfNeeded() treats as
+ * "re-arm and re-replay" (idempotent), not "finalized".  The flag lives in
+ * pg_control so it is updated durably in the same write as the rest of the
+ * control-file state.
+ */
+void
+SetControlFileUpgradeFinalized(void)
+{
+	Assert(ControlFile != NULL);
+
+	/*
+	 * Called from two contexts: the XLOG_UPGRADE_COMPLETE redo handler
+	 * (startup process, single-threaded recovery) and EmitUpgradeWalWindow()
+	 * on the live burst server (an ordinary backend, concurrent with the
+	 * checkpointer). Take ControlFileLock so the latter is safe; the former's
+	 * acquire is uncontended.
+	 */
+	LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
+	if (!ControlFile->upgrade_finalized)
+	{
+		ControlFile->upgrade_finalized = true;
+		UpdateControlFile();
+	}
+	LWLockRelease(ControlFileLock);
+}
+
+bool
+GetControlFileUpgradeFinalized(void)
+{
+	Assert(ControlFile != NULL);
+	return ControlFile->upgrade_finalized;
+}
+
+/*
+ * --wal-upgrade: durable "an upgrade window has been started here" flag.  Set on
+ * the burst server just before XLOG_UPGRADE_START is emitted, so a crash before
+ * COMPLETE leaves a durable trace (upgrade_started && !upgrade_finalized) that
+ * first-startup can refuse on, independent of whether the START-bearing WAL
+ * survived recycling.  See the field comment in pg_control.h.
+ */
+void
+SetControlFileUpgradeStarted(void)
+{
+	Assert(ControlFile != NULL);
+
+	/*
+	 * Like SetControlFileUpgradeFinalized(): may run on the live burst server
+	 * (an ordinary backend, concurrent with the checkpointer), so take the
+	 * lock.
+	 */
+	LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
+	if (!ControlFile->upgrade_started)
+	{
+		ControlFile->upgrade_started = true;
+		UpdateControlFile();
+	}
+	LWLockRelease(ControlFileLock);
+}
+
+bool
+GetControlFileUpgradeStarted(void)
+{
+	Assert(ControlFile != NULL);
+	return ControlFile->upgrade_started;
+}
+
 /*
  * Returns the unique system identifier from control file.
  */
@@ -5932,6 +6335,22 @@ StartupXLOG(void)
 									 timebuf, sizeof(timebuf)))));
 			break;
 
+		case DB_IN_UPGRADE:
+
+			/*
+			 * Crashed while replaying the upgrade window (informational
+			 * state).  PerformWalUpgradeIfNeeded() already re-armed at CN
+			 * before this point (resetting the state to DB_IN_PRODUCTION), so
+			 * this case is reached only if that arming was skipped; report it
+			 * honestly and let recovery proceed rather than FATAL as an
+			 * "invalid" state.
+			 */
+			ereport(LOG,
+					(errmsg("database system was interrupted while replaying a pg_upgrade window (last known up at %s)",
+							str_time(ControlFile->time,
+									 timebuf, sizeof(timebuf)))));
+			break;
+
 		default:
 			ereport(FATAL,
 					(errcode(ERRCODE_DATA_CORRUPTED),
@@ -6561,6 +6980,16 @@ StartupXLOG(void)
 	if (performedWalRecovery)
 		promoted = PerformRecoveryXLogAction();
 
+	/*
+	 * The --wal-upgrade new cluster comes up read-write on first start, as
+	 * ordinary pg_upgrade does.  Atomicity is enforced earlier:
+	 * PerformWalUpgradeIfNeeded() FATALs on a partial
+	 * (START-without-COMPLETE) local window before arming, so only a
+	 * fully-replayed window reaches this point and serves.  If the upgrade
+	 * result is unsatisfactory, the operator falls back to the untouched old
+	 * cluster (or a standby).
+	 */
+
 	/*
 	 * If any of the critical GUCs have changed, log them before we allow
 	 * backends to write WAL.
@@ -7116,6 +7545,21 @@ ShutdownXLOG(int code, Datum arg)
 	ereport(IsPostmasterEnvironment ? LOG : NOTICE,
 			(errmsg("shutting down")));
 
+	/*
+	 * pg_upgrade --wal-upgrade-signal-handoff: if it armed a handoff, emit
+	 * the XLOG_UPGRADE_HANDOFF trigger now, while WAL insertion is still
+	 * permitted and WAL senders are still active to stream it.  This runs
+	 * after the postmaster has drained all backends (fast shutdown waits for
+	 * PM_WAIT_BACKENDS before invoking the shutdown checkpoint), so every
+	 * user commit is already flushed at an LSN below the handoff; the
+	 * shutdown checkpoint that follows lands above it.  The handoff is
+	 * therefore the exact end of the old WAL stream a streaming standby stops
+	 * at, with no commit able to slip past it.  Only a live primary emits (a
+	 * standby replaying this record must not re-emit).
+	 */
+	if (!RecoveryInProgress())
+		EmitPgUpgradeHandoffIfArmed();
+
 	/*
 	 * Signal walsenders to move to stopping state.
 	 */
